Bug 489728 - Review Request: kcheckers - Checkers board game
Review Request: kcheckers - Checkers board game
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Ben Boeckel
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2009-03-11 11:34 EDT by Alexey Torkhov
Modified: 2009-09-30 20:03 EDT (History)
7 users (show)

See Also:
Fixed In Version: 0.8.1-4.fc10
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-09-30 20:03:25 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
mathstuf: fedora‑review+
a.badger: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Alexey Torkhov 2009-03-11 11:34:03 EDT
Spec URL: http://atorkhov.fedorapeople.org/kcheckers.spec
SRPM URL: http://atorkhov.fedorapeople.org/kcheckers-0.8.1-1.fc10.src.rpm
Description:

The Qt version of the classic board game checkers. This game is also
known as draughts.

Rpmlint output clean.
Comment 1 Alexey Torkhov 2009-03-20 18:06:00 EDT
Spec URL: http://atorkhov.fedorapeople.org/kcheckers.spec
SRPM URL: http://atorkhov.fedorapeople.org/kcheckers-0.8.1-2.fc10.src.rpm

* Fri Mar 20 2009 Alexey Torkhov <atorkhov@gmail.com> - 0.8.1-2
- Using find_lang to find qt translations
- Use desktop-file-install
Comment 2 nucleo 2009-03-21 15:24:28 EDT
May be it would be better to install icon in /usr/share/icons/hicolor/32x32/apps/
and update of icon cache.
Comment 3 Alexey Torkhov 2009-03-22 03:59:21 EDT
Spec URL: http://atorkhov.fedorapeople.org/kcheckers.spec
SRPM URL: http://atorkhov.fedorapeople.org/kcheckers-0.8.1-3.fc10.src.rpm

* Sat Mar 21 2009 Alexey Torkhov <atorkhov@gmail.com> - 0.8.1-3
- Install icon to hicolor theme
- Use qt-devel build requires instead of qt4-devel
Comment 4 Marcin Łabanowski 2009-04-08 16:28:39 EDT
Note that it's a practice review, I need to do some in order to get a sponsoring.

* Naming: OK
* Version and release: OK
* Legal: OK
* No inclusion of pre-built binaries or libraries: OK
* Spec Legibility: OK
* Writing a package from scratch: OK
* Modifying an existing package: N/A
* Architecture Support: DON'T KNOW (try a koji scratchbuild, I don't have a sponsor yet, so I can't test it for you)
* Filesystem layout: not-OK
- Locale files in %{_datadir}/%{name} - are you sure it's the best place?
* Use rpmlint: OK
* Changelogs: OK
* Tags: OK
* BuildRoot tag: OK
* Requires: OK
* BuildRequires: OK, mockbuild was successful
- I would rather suggest keeping qt4-devel in order to stay compatible with F8, even though it is not supported anymore.
* Summary and description: OK
* Encoding: OK
* Documentation: OK
* Compiler flags: not-OK
- Consider using %cmake macro (see: http://fedoraproject.org/wiki/Packaging/cmake )
* Debuginfo packages: OK
* Devel packages: N/A
* Requiring Base Package: N/A
* Shared Libraries: N/A
* Packaging Static Libraries: N/A
* Duplication of system libraries: OK
* Beware of Rpath: OK
* Configuration files: N/A
* Initscripts: N/A
* Desktop files: OK
- add: GenericName[pl]=Warcaby and Comment[pl]=Klasyczna gra planszowa - warcaby
* Macros: OK, but see my comment for compiler flags
* Handling Locale Files: OK, but see my comment for filesystem layout
* Timestamps: OK
* Parallel make: OK
* Scriptlets: OK
* Conditional dependencies: N/A
* Build packages with separate user accounts: not-OK ;)
* Relocatable packages: OK
* Code Vs Content: OK
* File and Directory Ownership: OK
* Users and Groups: N/A
* Web Applications: N/A
* Conflicts: OK
* No External Kernel Modules: OK
* No Files or Directories under /srv: OK
* Bundling of multiple projects: OK
* All patches should have an upstream bug link or comment: not-OK
- The Patch0 is Fedora-specific, but it doesn't say so. There is no description of it neither.
- The Patch1 should probably be sent back to upstream.
* Application Specific Guidelines: N/A
Comment 5 Alexey Torkhov 2009-04-08 18:49:47 EDT
(In reply to comment #4)
> Note that it's a practice review, I need to do some in order to get a
> sponsoring.

Great, thanks for comments!

> * Architecture Support: DON'T KNOW (try a koji scratchbuild, I don't have a
> sponsor yet, so I can't test it for you)

Here is the koji build:
http://koji.fedoraproject.org/koji/taskinfo?taskID=1286188

> * Filesystem layout: not-OK
> - Locale files in %{_datadir}/%{name} - are you sure it's the best place?

Those are QT locales, they are usually being put in program's share dir, as done here by upstream.

> * Compiler flags: not-OK
> - Consider using %cmake macro (see:
> http://fedoraproject.org/wiki/Packaging/cmake )

This is qmake, not cmake.

> * Desktop files: OK
> - add: GenericName[pl]=Warcaby and Comment[pl]=Klasyczna gra planszowa -
> warcaby

Game itself doesn't have Polish locale. Will think about adding this.

> * Build packages with separate user accounts: not-OK ;)

Um, why not OK?

> * All patches should have an upstream bug link or comment: not-OK
> - The Patch1 should probably be sent back to upstream.

Second patch is committed into upstream CVS two year ago.
Will add comments for patches in next package revision.
Comment 6 Marcin Łabanowski 2009-04-09 07:17:27 EDT
> Great, thanks for comments!
You're welcome ;)

> Those are QT locales, they are usually being put in program's share dir, as
done here by upstream.
I see, psi does it the same way, but for example arora puts these under %{_datadir}/%{name}/locale . Well, if other packages can keep it just under %{_datadir}/%{name}, I assume it's ok.

> This is qmake, not cmake.
Uhm, I was mistaken. Anyway, using optflags is a must, so please try at least:
CFLAGS="%{optflags}" CXXFLAGS="%{optflags}" make %{?_smp_mflags}

> Um, why not OK?
You didn't build as a separate user. While it is not necessary to build a correct package, this point is a part of the guidelines. And I noticed, that the SRPMS preserved ownership of an account which was named "alex", which I didn't suppose to be a separate account ;).
Comment 7 Jon Ciesla 2009-04-09 09:32:46 EDT
Linked spec and SRPM spec differ, using linked spec.

>- I would rather suggest keeping qt4-devel in order to stay compatible with F8,
>even though it is not supported anymore.

No.  Target rawhide, and modify the spec if necessary for older supported releases.  If someone needs to build for an unsupported release, they can modify it themselves.


Marcin, what exactly to you mean by separate user? Separate from what?  I see nothing about it here:

https://fedoraproject.org/wiki/Packaging/ReviewGuidelines

Which is what we should be using as our criteria.

SRPMS pick up ownership of the user under which the SRPM is built, but upon installation into a build tree, the files pick up the installing user's ownership.  This is normal.  You'll notice if you install a koji SRPM they report the user mockbuild as owner.

Otherwise, Marcin, your comments and Alexey's repsonses are good.
Comment 8 Alexey Torkhov 2009-04-09 10:06:12 EDT
(In reply to comment #6)
> > This is qmake, not cmake.
> Uhm, I was mistaken. Anyway, using optflags is a must, so please try at least:
> CFLAGS="%{optflags}" CXXFLAGS="%{optflags}" make %{?_smp_mflags}

The CFLAGS and CXXFLAGS are usually set by rpm itself. Some mangling with optflags is needed when some build system is doesn't respect them properly. You can check that optflags are actually used when building.
(Get optflags with "rpm -E %optflags" and look that it exist in build log)

> > Um, why not OK?
> You didn't build as a separate user. While it is not necessary to build a
> correct package, this point is a part of the guidelines. And I noticed, that
> the SRPMS preserved ownership of an account which was named "alex", which I
> didn't suppose to be a separate account ;).  

Ah, you are talking about this:
https://fedoraproject.org/wiki/Packaging/Guidelines#Build_packages_with_separate_user_accounts

Well, you're definitely right. I usually do builds in mock, but not in this case :)
Comment 9 Alexey Torkhov 2009-04-09 10:11:13 EDT
(In reply to comment #7)
> Linked spec and SRPM spec differ, using linked spec.

Sorry, here is the new release.

Spec URL: http://atorkhov.fedorapeople.org/kcheckers.spec
SRPM URL: http://atorkhov.fedorapeople.org/kcheckers-0.8.1-4.fc10.src.rpm

* Thu Apr 09 2009 Alexey Torkhov <atorkhov@gmail.com> - 0.8.1-4
- Adding comments for patches
Comment 10 Jon Ciesla 2009-04-09 10:13:26 EDT
Alexey is correct WRT flags.  And using mock is certainly a best practice, but has little bearing on the SRPM produced.  I typically use a seperate user account for local builds, and do mock to test BuildRequires, but that's just me, YMMV. :)
Comment 11 Marcin Łabanowski 2009-04-09 13:54:52 EDT
Oh, my mistake, I was looking at the moc commands. You're definitely right, the flags are set correctly.
Comment 12 Ben Boeckel 2009-07-27 17:17:31 EDT
[OK] MUST: rpmlint must be run on every package. The output should be posted in
the review.

% rpmlint kcheckers-*.rpm
3 packages and 0 specfiles checked; 0 errors, 0 warnings.

[OK] MUST: The spec file name must match the base package %{name}, in the
format %{name}.spec unless your package has an exemption.
[OK] MUST: The License field in the package spec file must match the actual
license.
[OK] MUST: The package must meet the  Packaging Guidelines . 
[OK] MUST: The package must be licensed with a Fedora approved license and meet
the  Licensing Guidelines . 
[OK] MUST: The License field in the package spec file must match the actual
license.
[OK] MUST: If (and only if) the source package includes the text of the
license(s) in its own file, then that file, containing the text of the
license(s) for the package must be included in %doc.
[OK] MUST: The spec file must be written in American English.
[OK] MUST: The spec file for the package MUST be legible.
[OK] MUST: The package <b>MUST</b> successfully compile and build into binary
rpms on at least one primary architecture.
[OK] MUST: If the package does not successfully compile, build or work on an
architecture, then those architectures should be listed in the spec in
ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in
bugzilla, describing the reason that the package does not compile/build/work on
that architecture. The bug number MUST be placed in a comment, next to the
corresponding ExcludeArch line.
[OK] MUST: The spec file MUST handle locales properly. This is done by using
the <code>%find_lang</code> macro. Using <code>%{_datadir}/locale/*</code> is
strictly forbidden.
[OK] MUST: Every binary RPM package (or subpackage) which stores shared library
files (not just symlinks) in any of the dynamic linker's default paths, must
call ldconfig in <code>%post</code> and <code>%postun</code>.
[OK] MUST: If the package is designed to be relocatable, the packager must
state this fact in the request for review, along with the rationalization for
relocation of that specific package. Without this, use of Prefix: /usr is
considered a blocker.
[OK] MUST: A package must own all directories that it creates. If it does not
create a directory that it uses, then it should require a package which does
create that directory.
[OK] MUST: A Fedora package must not list a file more than once in the spec
file's&nbsp;%files listings.
[OK] MUST: Permissions on files must be set properly. Executables should be set
with executable permissions, for example. Every <code>%files</code> section
must include a <code>%defattr(...)</code> line.
[OK] MUST: Each package must have a&nbsp;%clean section, which contains
<code>rm -rf&nbsp;%{buildroot}</code> (<a
href="/wiki/Packaging/Guidelines#UsingBuildRootOptFlags"
title="Packaging/Guidelines" class="mw-redirect">or $RPM_BUILD_ROOT</a>).
[OK] MUST: Each package must consistently use macros.
[OK] MUST: The package must contain code, or permissable content.
[OK] MUST: Large documentation files must go in a -doc subpackage. (The
definition of large is left up to the packager's best judgement, but is not
restricted to size. Large can refer to either size or quantity).
[OK] MUST: If a package includes something as&nbsp;%doc, it must not affect the
runtime of the application. To summarize: If it is in&nbsp;%doc, the program
must run properly if it is not present.
[OK] MUST: Header files must be in a -devel package.
[OK] MUST: Static libraries must be in a -static package.
[OK] MUST: Packages containing pkgconfig(.pc) files must 'Requires: pkgconfig'
(for directory ownership and usability).
[OK] MUST: If a package contains library files with a suffix
(e.g.libfoo.so.1.1), then library files that end in .so (without suffix) must
go in a -devel package.
[OK] MUST: In the vast majority of cases, devel packages must require the base
package using a fully versioned dependency: <code>Requires:&nbsp;%{name}
=&nbsp;%{version}-%{release} </code>
[OK] MUST: Packages must NOT contain any .la libtool archives, these must be
removed in the spec if they are built.
[OK] MUST: Packages containing GUI applications must include
a&nbsp;%{name}.desktop file, and that file must be properly installed with
desktop-file-install in the&nbsp;%install section. If you feel that your
packaged GUI application does not need a .desktop file, you must put a comment
in the spec file with your explanation.
[OK] MUST: Packages must not own files or directories already owned by other
packages. The rule of thumb here is that the first package to be installed
should own the files or directories that other packages may rely upon. This
means, for example, that no package in Fedora should ever share ownership with
any of the files or directories owned by the <code>filesystem</code> or
<code>man</code> package. If you feel that you have a good reason to own a file
or directory that another package owns, then please present that at package
review time.
[OK] MUST: At the beginning of <code>%install</code>, each package MUST run
<code>rm -rf&nbsp;%{buildroot}</code> (<a
href="/wiki/Packaging/Guidelines#UsingBuildRootOptFlags"
title="Packaging/Guidelines" class="mw-redirect">or $RPM_BUILD_ROOT</a>).
[OK] MUST: All filenames in rpm packages must be valid UTF-8.
[OK] SHOULD: If the source package does not include license text(s) as a
separate file from upstream, the packager SHOULD query upstream to include it.
[--] SHOULD: The description and summary sections in the package spec file
should contain translations for supported Non-English languages, if available.
[OK] SHOULD: The reviewer should test that the package builds in mock.
[OK] SHOULD: The package should compile and build into binary rpms on all
supported architectures.
[OK] SHOULD: The reviewer should test that the package functions as described.
A package should not segfault instead of running, for example.
[OK] SHOULD: If scriptlets are used, those scriptlets must be sane. This is
vague, and left up to the reviewers judgement to determine sanity.
[OK] SHOULD: Usually, subpackages other than devel should require the base
package using a fully versioned dependency.
[OK] SHOULD: The placement of pkgconfig(.pc) files depends on their usecase,
and this is usually for development purposes, so should be placed in a -devel
pkg.  A reasonable exception is that the main pkg itself is a devel tool not
installed in a user runtime, e.g. gcc or gdb.
[OK] SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin,
/usr/bin, or /usr/sbin consider requiring the package which provides the file
instead of the file itself.

Looks good, just have a few comments:

- Should it be renamed to qcheckers? Upstream seems to have renamed from kcheckers. It can still Provides: kcheckers for compatability.
- Please use BuildRequires: qt4-devel. EPEL/RHEL still has qt3 and when Qt5 is introduced, will not require changes here (Since then qt-devel will be Qt5 as well as qt5-devel).
Comment 13 Alexey Torkhov 2009-09-28 18:35:22 EDT
Sorry for long reply time - was on vacation and forgot about this after...

(In reply to comment #12)
> - Should it be renamed to qcheckers? Upstream seems to have renamed from
> kcheckers. It can still Provides: kcheckers for compatability.

Don't think so. Qcheckers has never had a release and likely will never have.

> - Please use BuildRequires: qt4-devel. EPEL/RHEL still has qt3 and when Qt5 is
> introduced, will not require changes here (Since then qt-devel will be Qt5 as
> well as qt5-devel).  

Yeah, may be your're right. Changed.

Spec URL: http://atorkhov.fedorapeople.org/kcheckers.spec
SRPM URL: http://atorkhov.fedorapeople.org/kcheckers-0.8.1-4.local12.src.rpm
Comment 14 Ben Boeckel 2009-09-28 18:48:01 EDT
I actually just looked at this about 10 minutes before your post ;) . Looks good.

APPROVED
Comment 15 Alexey Torkhov 2009-09-28 19:30:29 EDT
(In reply to comment #14)
> I actually just looked at this about 10 minutes before your post ;) . Looks
> good.
> 
> APPROVED  

Thanks for review :)


New Package CVS Request
=======================
Package Name: kchechers
Short Description: Checkers board game
Owners: atorkhov
Branches: F-10 F-11 F-12
Comment 16 Kevin Fenzi 2009-09-29 16:08:48 EDT
cvs done.
Comment 17 Alexey Torkhov 2009-09-29 16:22:00 EDT
Package Change Request
======================
Package Name: kcheckers
New Branches: 
Owners: atorkhov

Duh. Sorry, typo in package name: s/kchechers/kcheckers/
Comment 18 Toshio Ernie Kuratomi 2009-09-29 16:36:23 EDT
cvs done.
Comment 19 Fedora Update System 2009-09-29 17:41:33 EDT
kcheckers-0.8.1-4.fc10 has been submitted as an update for Fedora 10.
http://admin.fedoraproject.org/updates/kcheckers-0.8.1-4.fc10
Comment 20 Fedora Update System 2009-09-29 17:42:10 EDT
kcheckers-0.8.1-4.fc11 has been submitted as an update for Fedora 11.
http://admin.fedoraproject.org/updates/kcheckers-0.8.1-4.fc11
Comment 21 Fedora Update System 2009-09-30 20:03:18 EDT
kcheckers-0.8.1-4.fc11 has been pushed to the Fedora 11 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 22 Fedora Update System 2009-09-30 20:03:43 EDT
kcheckers-0.8.1-4.fc10 has been pushed to the Fedora 10 stable repository.  If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.